diff --git a/libr/core/cconfig.c b/libr/core/cconfig.c
index ca575e32ee9..a8f81f8a9ed 100644
--- a/libr/core/cconfig.c
+++ b/libr/core/cconfig.c
@@ -2159,6 +2159,7 @@ R_API int r_core_config_init(RCore *core) {
 	r_config_desc (cfg, "dbg.follow", "Follow program counter when pc > core->offset + dbg.follow");
 	SETCB ("dbg.swstep", "false", &cb_swstep, "Force use of software steps (code analysis+breakpoint)");
 	SETPREF ("dbg.trace.inrange", "false", "While tracing, avoid following calls outside specified range");
+	SETPREF ("dbg.trace.libs", "true", "Trace library code too");
 	SETPREF ("dbg.exitkills", "true", "Kill process on exit");
 	SETCB ("dbg.consbreak", "false", &cb_consbreak, "SIGINT handle for attached processes");
 
diff --git a/libr/core/cmd_debug.c b/libr/core/cmd_debug.c
index 91352d68287..eb990f5da19 100644
--- a/libr/core/cmd_debug.c
+++ b/libr/core/cmd_debug.c
@@ -2632,7 +2632,8 @@ static void trace_traverse (RTree *t) {
 }
 
 static void do_debug_trace_calls (RCore *core, ut64 from, ut64 to, ut64 final_addr) {
-	int shallow_trace = r_config_get_i (core->config, "dbg.trace.inrange");
+	bool shallow_trace = r_config_get_i (core->config, "dbg.trace.inrange");
+	bool trace_libs = r_config_get_i (core->config, "dbg.trace.libs");
 	Sdb *tracenodes = core->dbg->tracenodes;
 	RTree *tr = core->dbg->tree;
 	RDebug *dbg = core->dbg;
@@ -2640,6 +2641,12 @@ static void do_debug_trace_calls (RCore *core, ut64 from, ut64 to, ut64 final_ad
 	RTreeNode *cur;
 	int n = 0;
 
+	if (!trace_libs) {
+		shallow_trace = true;
+		RList *bounds = r_core_get_boundaries (core, "dbg.program", &from, &to);
+		r_list_free (bounds);
+	}
+
 	/* set root if not already present */
 	r_tree_add_node (tr, NULL, NULL);
 	cur = tr->root;
@@ -2650,17 +2657,21 @@ static void do_debug_trace_calls (RCore *core, ut64 from, ut64 to, ut64 final_ad
 		RAnalOp aop;
 		int addr_in_range;
 
-		if (r_cons_singleton ()->breaked)
+		if (r_cons_singleton ()->breaked) {
 			break;
-		if (r_debug_is_dead (dbg))
+		}
+		if (r_debug_is_dead (dbg)) {
 			break;
-		if (debug_to != UT64_MAX && !r_debug_continue_until (dbg, debug_to))
+		}
+		if (debug_to != UT64_MAX && !r_debug_continue_until (dbg, debug_to)) {
 			break;
-		else if (!r_debug_step (dbg, 1))
+		} else if (!r_debug_step (dbg, 1)) {
 			break;
+		}
 		debug_to = UT64_MAX;
-		if (!r_debug_reg_sync (dbg, R_REG_TYPE_GPR, false))
+		if (!r_debug_reg_sync (dbg, R_REG_TYPE_GPR, false)) {
 			break;
+		}
 		addr = r_debug_reg_get (dbg, "PC");
 		addr_in_range = addr >= from && addr < to;
 
@@ -2682,12 +2693,14 @@ static void do_debug_trace_calls (RCore *core, ut64 from, ut64 to, ut64 final_ad
 				r_debug_reg_sync (dbg, R_REG_TYPE_GPR, false);
 				called_addr = r_debug_reg_get (dbg, "PC");
 				called_in_range = called_addr >= from && called_addr < to;
-				if (!called_in_range && addr_in_range && shallow_trace)
+				if (!called_in_range && addr_in_range && shallow_trace) {
 					debug_to = addr;
+				}
 				if (addr_in_range) {
-					cur = add_trace_tree_child(tracenodes, tr, cur, addr);
-					if (debug_to != UT64_MAX)
+					cur = add_trace_tree_child (tracenodes, tr, cur, addr);
+					if (debug_to != UT64_MAX) {
 						cur = cur->parent;
+					}
 				}
 				// TODO: push pc+aop.length into the call path stack
 				break;
@@ -2695,12 +2708,14 @@ static void do_debug_trace_calls (RCore *core, ut64 from, ut64 to, ut64 final_ad
 		case R_ANAL_OP_TYPE_CALL:
 			{
 				int called_in_range = aop.jump >= from && aop.jump < to;
-				if (!called_in_range && addr_in_range && shallow_trace)
+				if (!called_in_range && addr_in_range && shallow_trace) {
 					debug_to = aop.addr + aop.size;
+				}
 				if (addr_in_range) {
-					cur = add_trace_tree_child(tracenodes, tr, cur, addr);
-					if (debug_to != UT64_MAX)
+					cur = add_trace_tree_child (tracenodes, tr, cur, addr);
+					if (debug_to != UT64_MAX) {
 						cur = cur->parent;
+					}
 				}
 				break;
 			}
@@ -2713,8 +2728,9 @@ static void do_debug_trace_calls (RCore *core, ut64 from, ut64 to, ut64 final_ad
 			// TODO: step into and check return address if correct
 			// if not correct we are hijacking the control flow (exploit!)
 #endif
-			if (cur != tr->root)
+			if (cur != tr->root) {
 				cur = cur->parent;
+			}
 #if 0
 			if (addr != gn->addr) {
 				eprintf ("Oops. invalid return address 0x%08"PFMT64x
diff --git a/libr/core/cmd_search.c b/libr/core/cmd_search.c
index 9f581c41b6a..9d78e8eaefd 100644
--- a/libr/core/cmd_search.c
+++ b/libr/core/cmd_search.c
@@ -655,9 +655,10 @@ R_API RList *r_core_get_boundaries_prot(RCore *core, int protection, const char
 		if (core->io->debug) {
 			int mask = 0;
 			int add = 0;
-			int heap = false;
-			int stack = false;
-			int all = false;
+			bool heap = false;
+			bool stack = false;
+			bool all = false;
+			bool first = false;
 			RListIter *iter;
 			RDebugMap *map;
 
@@ -687,19 +688,18 @@ R_API RList *r_core_get_boundaries_prot(RCore *core, int protection, const char
 					}
 				}
 			} else {
-				if (!strcmp (mode, "dbg.maps")) {
+				if (!strcmp (mode, "dbg.program")) {
+					first = true;
+					mask = R_IO_EXEC;
+				} else if (!strcmp (mode, "dbg.maps")) {
 					all = true;
-				}
-				if (!strcmp (mode, "dbg.maps.exec")) {
+				} else if (!strcmp (mode, "dbg.maps.exec")) {
 					mask = R_IO_EXEC;
-				}
-				if (!strcmp (mode, "dbg.maps.write")) {
+				} else if (!strcmp (mode, "dbg.maps.write")) {
 					mask = R_IO_WRITE;
-				}
-				if (!strcmp (mode, "dbg.heap")) {
+				} else if (!strcmp (mode, "dbg.heap")) {
 					heap = true;
-				}
-				if (!strcmp (mode, "dbg.stack")) {
+				} else if (!strcmp (mode, "dbg.stack")) {
 					stack = true;
 				}
 
@@ -733,6 +733,9 @@ R_API RList *r_core_get_boundaries_prot(RCore *core, int protection, const char
 						nmap->flags = map->perm;
 						nmap->delta = 0;
 						r_list_append (list, nmap);
+						if (first) {
+							break;
+						}
 					}
 				}
 			}
